{
ͻ
                              Unit  SuperVideo                               
                            for Turbo-PASCAL 5.0                             
         Copyright (c) 1991 by PaRuss Software.USSR.Kiev 562-23-09.          
͹
                         Autor : Boychenko Alexandr                          
͹
             Procedures :                          Functions:              
 Border     OnX         WriteChr       CtrlKey                             
 BCur       OnY         WriteStr       HowManyChr                          
 ChMask     Pause                      InputStr                            
 ClearKey   ScrMode                    PackAttr                            
 CloseWin   ScreenPg                   ScAd                                
 Cls        SWindow                    SeeChr                              
 Cursor     TAttrib                    SeeAttr                             
 GoX        TAttr                      UnPackBG                            
 GoY        VideoSeg                   UnPackTC                            
 InitBCur   VPoke                                                          
 KillBCur   WinBox                                                         
                                                                           
ͼ

}
UNIT SUPERV;

INTERFACE

  type
       DispRec     = record
                       Ch : char;
                       At : byte;
                     end;
       WindowMask  = string[6]  ;
       DispList    = array [1..25,1..80] of disprec;

  var
       Number_Window      :  byte;
       ScreenVec          : ^DispList;




{ -------------------------- Procedures ------------------------------------- }

  procedure Border     (c : byte);
  procedure BCur       (X,Y : word);
  procedure ChMask     (n : byte; newmask : windowmask);
  procedure ClearKey;
  procedure CloseWin;
  procedure Cls        (c : byte);
  procedure Cursor     (Kind : byte);
  procedure GoX        (X : byte);
  procedure GoY        (Y : byte);
  procedure InitBCur   (L,Hight,Kode,Att : byte; C : string);
  procedure KillBCur;
  procedure OnX        (X : shortint);
  procedure OnY        (Y : shortint);
  procedure Pause;
  procedure ScrMode    (m : byte);
  procedure ScreenPg   (n : byte);
  procedure SWindow    (k,x1,y1,x2,y2,c7,c8,c5,c6 : byte; name1,name2 : string);
  procedure TAttrib    (At,X1,Y1,X2,Y2 : byte);
  procedure TAttr      (At,X,Y : byte);

  procedure VideoSeg   (var seg : word);
  procedure VPoke      (c : char; l : word);
  procedure WinBox     (k,x1,y1,x2,y2 : byte);
  procedure WriteChr   (x,y,a : byte; c : char);
  procedure WriteStr   (x,y,a : byte; c : String);
  procedure ScrPalette (c : byte);














{ ----------------------------- Functions ----------------------------------- }

  function  CtrlKey                    : Word;
  function  HowManyChr (x,y : byte)    : byte;
  function  InputStr   (n : byte)      : string;
  function  PackAttr   (Txt,BG : byte) : byte;
  function  ScAd                       : pointer;
  function  SeeChar    (X,Y : byte)    : char;
  function  SeeAttr    (X,Y : byte)    : byte;
  function  UnPackBG   (Att : byte)    : byte;
  function  UnPackTC   (Att : byte)    : byte;










{ ---------------------------- Main Programm -------------------------------- }

IMPLEMENTATION

uses crt,dos;

var
       List              :  array [1..6] of displist;
       LastMask          :  windowmask;
       InitBigCursor     :  Boolean;
       CursorLength      :  Byte;
       CursorHight       :  Byte;
       CursorAttr        :  Byte;
       CursorMask        :  String[4];
       CursorCode        :  Byte;
       P                 :  Registers;

Procedure VideoSeg(var seg : word);
var l,pg:byte;
      k : word;
  begin
    p.ah:=15;
    intr($10,p);
    l:=p.al;
    pg:=p.bh;
    case l of
      0..6:seg:=$b800;
      7   :seg:=$b000;
     $d..$10:seg:=$a000;
    end;
    case l of
      0..1 : k:=25*5;
      2..3 : k:=25*10;
      4..6 : k:=5*200;
      7    : k:=25*5;
    end;
    seg:=seg+pg*k;
  end;

procedure ScreenPg(n:byte);
  begin
    p.ah:=5;
    p.al:=n;
    intr($10,p);
  end;

procedure ScrMode(m:byte);
  begin
    p.ah:=0;
    p.al:=m;
    intr($10,p);
  end;

function ScAd : pointer;
var s:word;
  begin
    videoseg(s);
    ScAd:=ptr(s,$0000);
  end;

procedure ClearKey;
  begin
    p.ah:=$0c;
    MsDos(p);
  end;

procedure Pause;
var a:char;
  begin
    if readkey=#0 then a:=readkey;
  end;

procedure VPoke(c:char;l:word);
  begin
    p.ah:=10;
    p.al:=ord(c);
    p.bh:=0;
    p.cx:=l;
    intr($10,p);
  end;

function CtrlKey : Word;
  begin
    p.ah:=2;
    intr($16,p);
    CtrlKey:=p.al;
  end;

procedure Cls(c:byte);
var c1:byte;
  begin
    c1:=TextAttr;
    TextAttr:=c;
    ClrScr;
    TextAttr:=c1;
  end;

procedure Cursor ( kind : byte);
  begin
    case kind of
      0 : begin           p.ch:=$20;end;
      1 : begin p.cl:=7;p.ch:=$07;end;
      2 : begin p.cl:=7;p.ch:=$06;end;
      3 : begin p.cl:=7;p.ch:=$05;end;
      4 : begin p.cl:=7;p.ch:=$04;end;
      5 : begin p.cl:=7;p.ch:=$03;end;
      6 : begin p.cl:=7;p.ch:=$02;end;
      7 : begin p.cl:=7;p.ch:=$01;end;
      8 : begin p.cl:=0;p.ch:=$07;end;
      9 : begin p.cl:=0;p.ch:=$06;end;
    end;
  p.ah:=1;
  intr($10,p);
end;

procedure gox(x:byte);
  begin
    gotoxy(x,wherey);
  end;

procedure goy(y:byte);
  begin
    gotoxy(wherex,y);
  end;

procedure onx(x:shortint);
  begin
    gotoxy(wherex+x,wherey);
  end;

function PackAttr(Txt,BG:byte):byte;
  begin
    PackAttr:=((Txt and 143) or ((BG and 7) shl 4));
  end;

function InputStr(n:byte):string;
label ext;
var a : byte;
    c : char;
    s : string;
  begin
    for a:=1 to n do
      begin
        c:=readkey;
        if c=#0 then c:=readkey
                else
                  begin
                    s[n]:=c;
                    if c=#27 then begin s:='';gox(1);a:=1;clreol;end;
                    if c=#13 then goto ext;
                    write(c);
                  end;
      end;
ext:InputStr:=s;
  end;

function UnPackTC(Att:byte):byte;
  begin
    UnPackTC:=Att and 143;
  end;

function UnPackBG(Att:byte):byte;
  begin
    UnPackBG:=(Att and 112) shr 4;
  end;

procedure ony(y:shortint);
  begin
    gotoxy(wherex,wherey+y);
  end;

function  SeeChar(X,Y:byte):char;
  begin
    ScreenVec:=ScAd;
    SeeChar:=ScreenVec^[Y,X].ch;
  end;

function  SeeAttr(X,Y:byte):byte;
  begin
    ScreenVec:=ScAd;
    SeeAttr:=ScreenVec^[Y,X].at;
  end;

procedure WriteChr(x,y,a:byte;c:char);
  begin
    ScreenVec:=scad;
    if ((x>80) or (y>25) or (x<1) or (y<1)) then exit;
    ScreenVec^[y,x].ch:=c;
    ScreenVec^[y,x].at:=a;
  end;

procedure WriteStr(x,y,a:byte;c:string);
var i:byte;
  begin
    for i:=1 to length(c) do
      begin
        if x>80 then begin x:=1;y:=y+1;end;
        if y>25 then exit;
        WriteChr(x,y,a,C[i]);
        x:=x+1;
      end;
  end;

procedure TAttr(At,X,Y:byte);
  begin
    x:=x mod 80;y:=y mod 25;
    if x=0 then x:=80;
    if y=0 then y:=25;
    ScreenVec:=scad;
    ScreenVec^[y,x].at:=at;
  end;

procedure TAttrib(at,x1,y1,x2,y2:byte);
  var
      x,y : byte;
  begin
    for y:=y1 to y2 do
      for x:=x1 to x2 do
        TAttr(at,x,y);
  end;

procedure Shadow(k,x1,y1,x2,y2:byte);
  begin
    case k of
      0:begin tattrib(7,x1+2,y2+1,x2+2,y2+1);tattrib(7,x2+1,y1+1,x2+2,y2+1);end;
      1:begin tattrib(7,x1-2,y2+1,x2-2,y2+1);tattrib(7,x1-2,y1+1,x1-1,y2+1);end;
      2:begin tattrib(7,x1+2,y1-1,x2+2,y1-1);tattrib(7,x2+1,y1-1,x2+2,y2-1);end;
      3:begin tattrib(7,x1-2,y1-1,x2-2,y1-1);tattrib(7,x1-2,y1-1,x1-1,y2-1);end;
      4:begin tattrib(7,x1+1,y2+1,x2+1,y2+1);tattrib(7,x2+1,y1+1,x2+1,y2+1);end;
      5:begin tattrib(7,x1-1,y2+1,x2-1,y2+1);tattrib(7,x1-1,y1+1,x1-1,y2+1);end;
      6:begin tattrib(7,x1+1,y1-1,x2+1,y1-1);tattrib(7,x2+1,y1-1,x2+1,y2-1);end;
      7:begin tattrib(7,x1-1,y1-1,x2-1,y1-1);tattrib(7,x1-1,y1-1,x1-1,y2-1);end;
    end;
  end;

procedure ChMask(n:byte;newmask:windowmask);
var
       maskwindow  :  array [1..4] of windowmask;
  begin
       maskwindow[1]:='ɻȼͺ';
       maskwindow[2]:='ڿĳ';
       maskwindow[3]:='ոԾͳ';
       maskwindow[4]:='ַӽĺ';
    if n=0 then
      begin
        n:=4;
        maskwindow[4]:=newmask;
      end;
    n:=(n mod 4)+1;
    lastmask:=maskwindow[n];
  end;

procedure WinBox(k,x1,y1,x2,y2:byte);
var
    c1,c2,c3,c4:byte;
  begin
    window(x1,y1,x2,y2);
    if k div 4>0 then
        TAttrib(textattr,x1,y1,x2,y2)
      else
        clrscr;
    if k>0 then chmask((k mod 4)+1,'');
    c1:=x2-x1+1;c2:=y2-y1+1;
    write(lastmask[1]);
    vpoke(lastmask[5],c1-2);
    gotoxy(2,c2);vpoke(lastmask[5],c1-2);
    for c3:=2 to c2-1 do
      begin
        gotoxy(1,c3);write(lastmask[6]);
        gotoxy(c1,c3);write(lastmask[6]);
      end;
    gotoxy(1,c2);write(lastmask[3]);
    gotoxy(c1,1);write(lastmask[2]);
    gotoxy(c1,c2);vpoke(lastmask[4],1);
  end;

procedure SWindow(k,x1,y1,x2,y2,c7,c8,c5,c6:byte;name1,name2:string);
  var
      c1, c2, c3, c4 :  byte;
  begin
    if k>127 then
      begin
        k:=k-128;
        ScreenVec:=scad;
        number_window:=number_window+1;
        if number_window>5 then
          number_window:=5;
        list[number_window]:=ScreenVec^;
      end;
    if k>63 then
      begin
        k:=k-64;
        shadow(k mod 8,x1,y1,x2,y2);
      end;
    textcolor(c7);textbackground(c8);
    Winbox(k div 8,x1,y1,x2,y2);
    c1:=x2-x1+1;c2:=y2-y1+1;
    c3:=length(name1);
    c4:=length(name2);
    textcolor(c5);gotoxy(c1 div 2-c3 div 2+1,1);write(name1);
    textcolor(c6);gotoxy(c1 div 2-c4 div 2+1,c2);write(name2);
    window(x1+1,y1+1,x2-1,y2-1);
    textcolor(c7);textbackground(c8);
  end;

procedure CloseWin;
  begin
    ScreenVec:=scad;
    ScreenVec^:=list[number_window];
    number_window:=number_window-1;
    if number_window=0 then number_window:=1;
  end;

procedure Border(c:byte);
  begin
    p.ah:=11;
    p.bx:=c;
    intr($10,p);
  end;

procedure ScrPalette(c:byte);
  begin
    p.ah:=11;
    p.bh:=1;
    p.bl:=c;
    intr($10,p);
  end;

Procedure InitBCur(L,Hight,Kode,Att:byte;C:string);
  Begin
    InitBigCursor:= True;
    CursorLength := L;
    CursorHight  := Hight;
    CursorAttr   := Att;
    CursorCode   := Kode;
    CursorMask   := C;
    List[6]      :=ScreenVec^;
  End;

function HowManyChr(x,y:byte):byte;
label 10;
var c:char;
    x1,cr,a:byte;
  begin
    cr:=0;
    a:=0;
    for x1:=x to 80 do
      begin
        c:=ScreenVec^[y,x1].ch;
        if (c<>#32) and (c<>#0) then
          begin
            cr:=1;a:=a+1;
          end
         else
          if (cr=1) and ((c=#32) or (c=#0)) then goto 10 else a:=a+1;
      end;
10:   HowManyChr:=a;
    end;

Procedure BCur(x,y:word);
var oldx,oldy : word;
    r1,r2,r3,r4,endstr: byte;
    chars:char;
  begin
    if Not InitBigCursor then begin oldx:=0;oldy:=0;exit;end;
    r1:=CursorCode;
    r2:=(r1 and 3);
    case r2 of
      1 : Cursorlength:=HowManyChr(x,y);
      2 : begin
            Cursorlength:=HowManyChr(x,y)+2;
            X:=X-1;if x<1 then x:=1;dec(CursorLength);
          end;
    end;
    endstr:=x+CursorLength-1;
    if endstr>80 then exit;
    if y+CursorHight>25 then exit;
    if (oldx>0) and (oldy>0) then
      begin
        ScreenVec^:=List[6];
        Oldx:=x;
        Oldy:=y;
      end
     else exit;
    List[6]:=ScreenVec^;
    r2:=(r1 and 32) shr 5;
    if r2=1 then
      for r3:=x to (endstr) do
        begin
          chars:=UpCase(ScreenVec^[y,r3].ch);
          ScreenVec^[y,r3].ch:=chars;
        end;
    r2:=(r1 and 16) shr 4;
    if r2=1 then
      begin
        r2:=(r1 and 64) shr 6;
        if r2=0 then
          begin
            r3:=x-1;
            if r3<1 then r3:=x;
            WriteChr(r3,y,Textattr,CursorMask[1]);
          end
         else
          begin
            r3:=x-1;
            if r3<1 then r3:=x else x:=x-1;
            r4:=endstr+1;
            if r4>80 then r4:=80;
            writeChr(r3,y,Textattr,CursorMask[1]);
            WriteChr(r4,y,Textattr,CursorMask[2]);
            inc(endstr);
            if endstr>80 then endstr:=80;
          end;
      end;
    r2:=((r1 and 12) shr 2);
    r1:=((r1 and 128) shr 7);
    for r3:=x to (endstr) do
      begin
        r4:=ScreenVec^[y,r3].at;
        case r2 of
          0 : if r1=1 then screenvec^[y,r3].at:=((r4 and ord(Cursormask[3])) xor ord(cursormask[4]));
          1 : if r1=0 then screenvec^[y,r3].at:=(r4 or (CursorAttr and 143))
                      else screenvec^[y,r3].at:=(r4 xor 15);
          2 : if r1=0 then screenvec^[y,r3].at:=(r4 or (CursorAttr and 112))
                      else screenvec^[y,r3].at:=(r4 xor 112);
          3 : if r1=0 then ScreenVec^[y,r3].at:=CursorAttr
                      else ScreenVec^[y,r3].at:=(r4 xor 255);
        end;
     end;
  end;

Procedure KillBCur;
  begin
    CursorHight:=0;
    CursorAttr :=7;
    CursorLength:=0;
    InitBigCursor:=False;
    ScreenVec^:=list[6];
  end;

begin
  lastmask:='ɻȼͺ';
  delay(0);
  Number_Window:=0;
  ScreenVec:=ScAd;
  InitBigCursor:=False;
  List[6]:=ScreenVec^;
end.